Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DefineExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DefineExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DefineExpressions.cs	(revision 14602)
@@ -1,4 +1,3 @@
-﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
   using System;
   using System.Collections.Generic;
@@ -12,12 +11,12 @@
   /// </summary>
   /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class DefineExpression<T> : StatelessExpression
-  {
+  public abstract class DefineExpression<T> : StatelessExpression {
+    protected DefineExpression(string stringRepresentation) : base(stringRepresentation) { }
+
     protected void Eval(
       IStack<T> stack,
       IStack<string> nameStack,
       IDictionary<string, Expression> customExpressions,
-      Func<T, Expression> creator)
-    {
+      Func<T, Expression> creator) {
       // not enough arguments on stack
       if ((nameStack.Count == 0) || (stack.Count < 1)) return;
@@ -31,13 +30,8 @@
   }
 
-  public class CodeDefineExpression : DefineExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.DEFINE";
-    }
+  public class CodeDefineExpression : DefineExpression<Expression> {
+    public CodeDefineExpression() : base("CODE.DEFINE") { }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
+    public override void Eval(IPushGpInterpreter interpreter) {
       if (interpreter.Configuration.TopLevelPushCode && (interpreter.CodeStack.Count < 2)) return;
 
@@ -52,13 +46,8 @@
   }
 
-  public class ExecDefineExpression : DefineExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.DEFINE";
-    }
+  public class ExecDefineExpression : DefineExpression<Expression> {
+    public ExecDefineExpression() : base("EXEC.DEFINE") { }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
+    public override void Eval(IPushGpInterpreter interpreter) {
       if (interpreter.ExecStack.Count < 2) return;
 
@@ -73,13 +62,8 @@
   }
 
-  public class FloatDefineExpression : DefineExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.DEFINE";
-    }
+  public class FloatDefineExpression : DefineExpression<double> {
+    public FloatDefineExpression() : base("FLOAT.DEFINE") { }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
+    public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(
         interpreter.FloatStack,
@@ -90,13 +74,8 @@
   }
 
-  public class IntegerDefineExpression : DefineExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.DEFINE";
-    }
+  public class IntegerDefineExpression : DefineExpression<long> {
+    public IntegerDefineExpression() : base("INTEGER.DEFINE") { }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
+    public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(
         interpreter.IntegerStack,
@@ -107,13 +86,8 @@
   }
 
-  public class BooleanDefineExpression : DefineExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.DEFINE";
-    }
+  public class BooleanDefineExpression : DefineExpression<bool> {
+    public BooleanDefineExpression() : base("BOOLEAN.DEFINE") { }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
+    public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(
         interpreter.BooleanStack,
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoCountExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoCountExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoCountExpressions.cs	(revision 14602)
@@ -4,6 +4,12 @@
 
   public abstract class DoCountExpression : LoopExpression {
+    protected DoCountExpression(string stringRepresentation)
+      : base(stringRepresentation) {
+    }
+
     protected override bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
-      return (interpreter.IntegerStack.Count < 1) || (sourceStack.Count == 0) || (interpreter.IntegerStack.Top <= 0);
+      return interpreter.IntegerStack.Count < 1 ||
+             sourceStack.Count == 0 ||
+             interpreter.IntegerStack.Top <= 0;
     }
 
@@ -32,7 +38,5 @@
   /// </summary>
   public class CodeDoCountExpression : DoCountExpression {
-    protected override string InitStringRepresentation() {
-      return "CODE.DO*COUNT";
-    }
+    public CodeDoCountExpression() : base("CODE.DO*COUNT") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -56,8 +60,5 @@
   /// </summary>
   public class ExecDoCountExpression : DoCountExpression {
-    protected override string InitStringRepresentation() {
-      return "EXEC.DO*COUNT";
-    }
-
+    public ExecDoCountExpression() : base("EXEC.DO*COUNT") { }
     public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(interpreter, interpreter.ExecStack);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoRangeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoRangeExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoRangeExpressions.cs	(revision 14602)
@@ -4,7 +4,10 @@
 
   public abstract class DoRangeExpression : LoopExpression {
+    protected DoRangeExpression(string stringRepresentation) : base(stringRepresentation) { }
+
     protected override bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
-      return (interpreter.IntegerStack.Count < 2) || (sourceStack.Count == 0)
-             || (interpreter.IntegerStack.Top == interpreter.IntegerStack.ReverseElementAt(1));
+      return interpreter.IntegerStack.Count < 2 ||
+             sourceStack.Count == 0 ||
+             interpreter.IntegerStack.Top == interpreter.IntegerStack.ReverseElementAt(1);
     }
 
@@ -41,7 +44,5 @@
   /// </summary>
   public class CodeDoRangeExpression : DoRangeExpression {
-    protected override string InitStringRepresentation() {
-      return "CODE.DO*RANGE";
-    }
+    public CodeDoRangeExpression() : base("CODE.DO*RANGE") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -75,7 +76,5 @@
   /// </summary>
   public class ExecDoRangeExpression : DoRangeExpression {
-    protected override string InitStringRepresentation() {
-      return "EXEC.DO*RANGE";
-    }
+    public ExecDoRangeExpression() : base("EXEC.DO*RANGE") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs	(revision 14602)
@@ -4,4 +4,5 @@
 
   public abstract class DoTimesExpression : LoopExpression {
+    protected DoTimesExpression(string stringRepresentation) : base(stringRepresentation) { }
     protected override bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
       return (interpreter.IntegerStack.Count < 1) || (sourceStack.Count == 0) || (interpreter.IntegerStack.Top <= 0);
@@ -31,7 +32,5 @@
   /// </summary>
   public class CodeDoTimesExpression : DoTimesExpression {
-    protected override string InitStringRepresentation() {
-      return "CODE.DO*TIMES";
-    }
+    public CodeDoTimesExpression() : base("CODE.DO*TIMES") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -50,7 +49,5 @@
   /// </summary>
   public class ExecDoTimesExpression : DoTimesExpression {
-    protected override string InitStringRepresentation() {
-      return "EXEC.DO*TIMES";
-    }
+    public ExecDoTimesExpression() : base("EXEC.DO*TIMES") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs	(revision 14602)
@@ -1,107 +1,105 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using HeuristicLab.Algorithms.PushGP.Interpreter;
+    using HeuristicLab.Algorithms.PushGP.Stack;
 
-  /// <summary>
-  ///     Duplicates the top item on the INTEGER stack. Does not pop its argument
-  ///     (which, if it did, would negate the effect of the duplication!).
-  /// </summary>
-  /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class DuplicateExpression<T> : StatelessExpression
-  {
-    protected void Eval(IStack<T> stack)
+    /// <summary>
+    ///     Duplicates the top item on the INTEGER stack. Does not pop its argument
+    ///     (which, if it did, would negate the effect of the duplication!).
+    /// </summary>
+    /// <typeparam name="T">Stacktype</typeparam>
+    public abstract class DuplicateExpression<T> : StatelessExpression
     {
-      if (stack.Count == 0) return;
+        protected DuplicateExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
 
-      stack.Push(stack.Top);
+        protected void Eval(IStack<T> stack)
+        {
+            if (stack.Count == 0) return;
+
+            stack.Push(stack.Top);
+        }
+
+        protected void Eval(IStack<Expression> stack)
+        {
+            if (stack.Count == 0) return;
+
+            var top = stack.Top;
+
+            stack.Push(top);
+        }
     }
 
-    protected void Eval(IStack<Expression> stack)
+    public class IntegerDuplicateExpression : DuplicateExpression<long>
     {
-      if (stack.Count == 0) return;
+        public IntegerDuplicateExpression() : base("INTEGER.DUP")
+        {
+        }
 
-      var top = stack.Top;
-
-      stack.Push(top);
-    }
-  }
-
-  public class IntegerDuplicateExpression : DuplicateExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.DUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class FloatDuplicateExpression : DuplicateExpression<double>
     {
-      this.Eval(interpreter.IntegerStack);
-    }
-  }
+        public FloatDuplicateExpression() : base("FLOAT.DUP")
+        {
+        }
 
-  public class FloatDuplicateExpression : DuplicateExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.DUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class BooleanDuplicateExpression : DuplicateExpression<bool>
     {
-      this.Eval(interpreter.FloatStack);
-    }
-  }
+        public BooleanDuplicateExpression() : base("BOOLEAN.DUP")
+        {
+        }
 
-  public class BooleanDuplicateExpression : DuplicateExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.DUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NameDuplicateExpression : DuplicateExpression<string>
     {
-      this.Eval(interpreter.BooleanStack);
-    }
-  }
+        public NameDuplicateExpression() : base("NAME.DUP")
+        {
+        }
 
-  public class NameDuplicateExpression : DuplicateExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.DUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.NameStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecDuplicateExpression : DuplicateExpression<Expression>
     {
-      this.Eval(interpreter.NameStack);
-    }
-  }
+        public ExecDuplicateExpression() : base("EXEC.DUP")
+        {
+        }
 
-  public class ExecDuplicateExpression : DuplicateExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.DUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.ExecStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodeDuplicateExpression : DuplicateExpression<Expression>
     {
-      this.Eval(interpreter.ExecStack);
+        public CodeDuplicateExpression() : base("CODE.DUP")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.CodeStack);
+        }
     }
-  }
-
-  public class CodeDuplicateExpression : DuplicateExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.DUP";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.CodeStack);
-    }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs	(revision 14602)
@@ -2,4 +2,5 @@
   using HeuristicLab.Algorithms.PushGP.Generators;
   using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
   /// <summary>
@@ -7,18 +8,14 @@
   /// </summary>
   /// <typeparam name="T"></typeparam>
-  public abstract class ErcExpression<T> : PushExpression<T> {
-    protected ErcExpression(T value) : base(value) { }
+  public abstract class ErcExpression<T> : StatefullExpression<T> {
+    protected ErcExpression(T value, string stringRepresentation) : base(value, stringRepresentation) { }
 
-    protected override string InitStringRepresentation() {
-      return string.Format("{0}({1})", this.GetType().Name, this.State);
-    }
-
-    protected override int InitId() {
-      return this.State.GetHashCode();
+    protected void Eval(IStack<T> stack) {
+      stack.Push(this.State);
     }
   }
 
   public class IntegerErcExpression : ErcExpression<long> {
-    public IntegerErcExpression() : base(IntegerGenerator.RandomInteger()) { }
+    public IntegerErcExpression() : base(IntegerGenerator.RandomInteger(), "INTEGER.ERC") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -28,5 +25,5 @@
 
   public class FloatErcExpression : ErcExpression<double> {
-    public FloatErcExpression() : base(FloatGenerator.RandomFloat()) { }
+    public FloatErcExpression() : base(FloatGenerator.RandomFloat(), "FLOAT.ERC") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -36,5 +33,5 @@
 
   public class BooleanErcExpression : ErcExpression<bool> {
-    public BooleanErcExpression() : base(BooleanGenerator.RandomBoolean()) { }
+    public BooleanErcExpression() : base(BooleanGenerator.RandomBoolean(), "BOOLEAN.ERC") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -44,5 +41,5 @@
 
   public class NameErcExpression : ErcExpression<string> {
-    public NameErcExpression() : base(NameGenerator.RandomName()) { }
+    public NameErcExpression() : base(NameGenerator.RandomName(), "NAME.ERC") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs	(revision 14602)
@@ -1,99 +1,97 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using HeuristicLab.Algorithms.PushGP.Interpreter;
+    using HeuristicLab.Algorithms.PushGP.Stack;
 
-  /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the top two items are equal, or FALSE otherwise
-  /// </summary>
-  /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class EqualsExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack, IStack<bool> booleanStack)
+    /// <summary>
+    ///     Pushes TRUE onto the BOOLEAN stack if the top two items are equal, or FALSE otherwise
+    /// </summary>
+    /// <typeparam name="T">Stacktype</typeparam>
+    public abstract class EqualsExpression<T> : StatelessExpression
     {
-      if (stack.Count < 2) return;
+        protected EqualsExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
 
-      var items = stack.Pop(2);
+        public void Eval(IStack<T> stack, IStack<bool> booleanStack)
+        {
+            if (stack.Count < 2) return;
 
-      booleanStack.Push(items[0].Equals(items[1]));
-    }
-  }
+            var items = stack.Pop(2);
 
-  public class IntegerEqualsExpression : EqualsExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.=";
+            booleanStack.Push(items[0].Equals(items[1]));
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class IntegerEqualsExpression : EqualsExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, interpreter.BooleanStack);
-    }
-  }
+        public IntegerEqualsExpression() : base("INTEGER.=")
+        {
+        }
 
-  public class FloatEqualsExpression : EqualsExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.=";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class FloatEqualsExpression : EqualsExpression<double>
     {
-      this.Eval(interpreter.FloatStack, interpreter.BooleanStack);
-    }
-  }
+        public FloatEqualsExpression() : base("FLOAT.=")
+        {
+        }
 
-  public class BooleanEqualsExpression : EqualsExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.=";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class BooleanEqualsExpression : EqualsExpression<bool>
     {
-      this.Eval(interpreter.BooleanStack, interpreter.BooleanStack);
-    }
-  }
+        public BooleanEqualsExpression() : base("BOOLEAN.=")
+        {
+        }
 
-  public class NameEqualsExpression : EqualsExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.=";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.BooleanStack, interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NameEqualsExpression : EqualsExpression<string>
     {
-      this.Eval(interpreter.NameStack, interpreter.BooleanStack);
-    }
-  }
+        public NameEqualsExpression() : base("NAME.=")
+        {
+        }
 
-  public class ExecEqualsExpression : EqualsExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.=";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.NameStack, interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecEqualsExpression : EqualsExpression<Expression>
     {
-      this.Eval(interpreter.ExecStack, interpreter.BooleanStack);
-    }
-  }
+        public ExecEqualsExpression() : base("EXEC.=")
+        {
+        }
 
-  public class CodeEqualsExpression : EqualsExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.=";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.ExecStack, interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodeEqualsExpression : EqualsExpression<Expression>
     {
-      this.Eval(interpreter.CodeStack, interpreter.BooleanStack);
+        public CodeEqualsExpression() : base("CODE.=")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.CodeStack, interpreter.BooleanStack);
+        }
     }
-  }
 }
